
#ifndef DMA_H
#define DMA_H

#include "abstract-dma.hpp"
#include "dma-register.hpp"
#include "stm32f072xb.h"
#include "uart.hpp"

namespace stm32f072xb {

template <DmaChannel T, DmaPeripheral P>
class Dma {};

template <>
class Dma<DmaChannel::CHANNEL4, DmaPeripheral::USART2_TX> : public AbstractDma {
   public:
	Dma(AbstractDmaInit& dmaInit, Uart<UartRegister::UART2, Port::A>& uart);
};

template <>
class Dma<DmaChannel::CHANNEL5, DmaPeripheral::USART2_RX> : public AbstractDma {
   public:
	Dma(AbstractDmaInit& dmaInit, Uart<UartRegister::UART2, Port::A>& uart);
};

}  // namespace stm32f072xb
#endif
